#ifndef HASH_H
#define HASH_H

typedef struct hashobject {
  char *string;
  void *object;
} hashobject;

struct hashtable { 
  unsigned int size;
  unsigned int numelements; /* number of objects inserted into hashtable */
  hashobject *table;
};

typedef struct hashtable *hashtable;

extern hashtable HashCreate(int size);
extern void HashDestroy(hashtable table);
extern void HashInsert(hashtable table, void *object, char *string);
extern void HashDelete(hashtable table, char *string);
extern void *HashLookup(hashtable table, char *string);
extern void HashApply(hashtable table,void (*fun)(char *str,void *obj));
#endif /* HASH_H */



